<template>
  <div>
    <el-dialog  v-model="visible" :z-index="99" :title="title" width="700" align-center >
      <el-form :inline="true" :rules="rules" :model="modalForm" class="demo-form-inline" ref="ruleFormRef">
        <div class="barbox" style="margin-top: -10px;">
          <div class="bar"></div>
          <div class="name">单项配置信息</div>
        </div>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="首单价格：" prop="first_time_price">
              <el-input min="0" type="number" v-model="modalForm.first_time_price" style="width: 200px" placeholder="请输入首单价格" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="购买后有效天数：" prop="valid_days">
              <el-input v-model.number="modalForm.valid_days" style="width: 200px" placeholder="请输入会员时长" />
            </el-form-item>
          </el-col>
          </el-row>
      </el-form>
      <el-divider />
      <div class="barbox">
        <div class="bar"></div>
        <div class="name">操作</div>
      </div>
      <el-row :gutter="20">
        <el-col :span="16">
          <el-form-item label="" style="padding-left:30px">
            <el-button @click="visible = false">取消</el-button>
            <el-button type="primary" @click="submit(ruleFormRef)">
              确定
            </el-button>
          </el-form-item>
        </el-col>
      </el-row>

      <!-- <template #footer>
      <div class="dialog-footer">
        <el-button @click="visible = false">取消</el-button>
        <el-button type="primary" @click="submit">
          确定
        </el-button>
      </div>
    </template> -->
    </el-dialog>
    <el-dialog v-model="dialogVisible" title="温馨提示" width="400">
      <span>确定取消该订单？</span>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="dialogVisible = false">取消</el-button>
          <el-button type="primary" @click="confirmCancel">
            Confirm
          </el-button>
        </div>
      </template>
    </el-dialog>
  </div>

</template>

<script setup>
import { onBeforeMount, reactive, ref, nextTick } from 'vue';
import { useRouter, useRoute } from 'vue-router'
import userApi from "../api/user";
import { ElMessage } from "element-plus";
import { formatOrderStatus, formatRefundStatus, formatDate } from '../utils/format'

const ruleFormRef = ref(null);
const method=ref(null);
const emit=defineEmits(['refreshList']);
const modalForm = reactive({
  system_member_id: ''
})
const rules = reactive({
 first_time_price:[
    {
      required: true,
      message: '请输入首单价格',

      trigger: 'blur',
    }
  ],
  valid_days:[
    {
      required: true,
      message: '请输入购买后有效天数',
      trigger: 'blur',

   }
  ],


});
const handleAdd = () => {
  if(!modalForm.system_member_id){
    delete modalForm.system_member_id
  };
  if(modalForm.first_time_price){
    modalForm.first_time_price=Number(modalForm.first_time_price);
  }
  if(modalForm.first_time_price!==''){
     if(modalForm.first_time_price<=0){
      ElMessage.error('价格不能小于0');
      return
     }
  }
  userApi.saveItemSetting(modalForm).then((res) => {
    let result = res;
   
    if (result.code == 200) {
        ElMessage.success("添加成功");
        visible.value = false;
        emit('refreshList')
    }

  })
};
const handleEdit = () => {
  if(modalForm.first_time_price){
    modalForm.first_time_price=Number(modalForm.first_time_price);
  }
  if(modalForm.first_time_price!==''){
     if(modalForm.first_time_price<=0){
      ElMessage.error('价格不能小于0');
      return
     }
  }
  userApi.editItemSetting(modalForm.system_member_id,modalForm).then((res) => {
    let result = res;
   
    if (result.code == 200) {
        ElMessage.success("修改成功");
        visible.value = false;
        emit('refreshList')
    }

  })
};


const submit = async(form) => {
  await form.validate((valid, fields) => {
    if (valid) {
      method.value === 'edit'?handleEdit() : handleAdd()
    } else {
      console.log('error submit!', fields)
    }
 
  });
}
const visible = ref(false);
const dialogVisible = ref(false);
const title = ref('订单详情')
const route = useRoute();
const router = useRouter();


const cancelOrder = () => {

};
const confirmCancel = () => {
  dialogVisible.value = false;
  cancelOrder()

}

const init = (type, id) => {
  visible.value = true;
  method.value = type;
  modalForm.system_member_id = id;
  if (method.value === 'edit') {
    title.value = '编辑单项配置'
  } else if (method.value === 'view') {
    title.value = '新建单项配置'
  }
 
  nextTick(() => {
    ruleFormRef.value.resetFields();
    modalForm.discount_end_time = '';
    if (method.value === 'edit') {
      userApi.getItemSettingDetail(modalForm.system_member_id).then((res) => {
        let result = res.data;
        Object.assign(modalForm, result);

      })
    }
  })

}

defineExpose({
  init
});
</script>

<style lang="scss" scoped>
.barbox {
  margin: 10px 0;
  display: flex;
  align-items: center;

  .bar {
    width: 4px;
    height: 25px;
    background: var(--el-color-primary);
  }

  .name {
    margin-left: 8px;
    font-size: 16px;
  }
}
</style>